Index: src/language/dictionary/variable-display.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/variable-display.c,v
retrieving revision 1.10
diff -u -p -r1.10 variable-display.c
--- src/language/dictionary/variable-display.c	11 Nov 2006 23:10:00 -0000	1.10
+++ src/language/dictionary/variable-display.c	5 Dec 2006 06:36:43 -0000
@@ -71,9 +71,8 @@ cmd_variable_alignment (struct lexer *le
           return CMD_FAILURE; 
         }
 
-      for( i = 0 ; i < nv ; ++i ) 
-	v[i]->alignment = align;
-
+      for( i = 0 ; i < nv ; ++i )
+        var_set_alignment (v[i], align);
 
       while (lex_token (lexer) == '/')
 	lex_get (lexer);
@@ -110,7 +109,7 @@ cmd_variable_width (struct lexer *lexer,
 	}
 
       for( i = 0 ; i < nv ; ++i ) 
-	  v[i]->display_width = lex_tokval (lexer);
+        var_set_display_width (v[i], lex_integer (lexer));
 
       while (lex_token (lexer) == '/')
 	lex_get (lexer);
@@ -158,7 +157,7 @@ cmd_variable_level (struct lexer *lexer,
         }
       
       for( i = 0 ; i < nv ; ++i ) 
-	v[i]->measure = level ;
+	var_set_measure (v[i], level);
 
 
       while (lex_token (lexer) == '/')
Index: src/language/dictionary/variable-label.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/variable-label.c,v
retrieving revision 1.11
diff -u -p -r1.11 variable-label.c
--- src/language/dictionary/variable-label.c	11 Nov 2006 23:10:00 -0000	1.11
+++ src/language/dictionary/variable-label.c	5 Dec 2006 06:36:43 -0000
@@ -62,11 +62,7 @@ cmd_variable_labels (struct lexer *lexer
 	  ds_truncate (&label, 255);
 	}
       for (i = 0; i < nv; i++)
-	{
-	  if (v[i]->label)
-	    free (v[i]->label);
-	  v[i]->label = ds_xstrdup (&label);
-	}
+        var_set_label (v[i], ds_cstr (&label));
       ds_destroy (&label);
 
       lex_get (lexer);
@@ -83,8 +79,11 @@ cmd_variable_labels (struct lexer *lexer
 const char *
 var_to_string(const struct variable *var)
 {
+  const char *label;
+  
   if ( !var ) 
     return 0;
 
-  return ( var->label ? var->label : var->name);
+  label = var_get_label (var);
+  return label ? label : var_get_name (var);
 }
Index: src/language/dictionary/weight.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/weight.c,v
retrieving revision 1.8
diff -u -p -r1.8 weight.c
--- src/language/dictionary/weight.c	11 Nov 2006 23:10:00 -0000	1.8
+++ src/language/dictionary/weight.c	5 Dec 2006 06:36:43 -0000
@@ -47,12 +47,12 @@ cmd_weight (struct lexer *lexer, struct 
       v = parse_variable (lexer, dict);
       if (!v)
 	return CMD_CASCADING_FAILURE;
-      if (v->type == ALPHA)
+      if (var_is_alpha (v))
 	{
 	  msg (SE, _("The weighting variable must be numeric."));
 	  return CMD_CASCADING_FAILURE;
 	}
-      if (dict_class_from_id (v->name) == DC_SCRATCH)
+      if (dict_class_from_id (var_get_name (v)) == DC_SCRATCH)
 	{
 	  msg (SE, _("The weighting variable may not be scratch."));
 	  return CMD_CASCADING_FAILURE;
Index: src/language/expressions/evaluate.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/evaluate.c,v
retrieving revision 1.11
diff -u -p -r1.11 evaluate.c
--- src/language/expressions/evaluate.c	22 Nov 2006 04:24:02 -0000	1.11
+++ src/language/expressions/evaluate.c	5 Dec 2006 06:36:43 -0000
@@ -183,7 +183,7 @@ cmd_debug_evaluate (struct lexer *lexer,
             case_data_rw (c, v->fv)->f = lex_tokval (lexer);
           else
             memcpy (case_data_rw (c, v->fv)->s, ds_data (lex_tokstr (lexer)),
-                    v->width);
+                    var_get_width (v));
           lex_get (lexer);
 
           if (!lex_force_match (lexer, ')'))
@@ -309,7 +309,7 @@ expr_debug_print_postfix (const struct e
           }
           break;
         case OP_variable:
-          fprintf (stderr, "v<%s>", op->variable->name);
+          fprintf (stderr, "v<%s>", var_get_name (op->variable));
           break;
         case OP_vector:
           fprintf (stderr, "vec<%s>", op->vector->name);
Index: src/language/expressions/operations.def
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/operations.def,v
retrieving revision 1.9
diff -u -p -r1.9 operations.def
--- src/language/expressions/operations.def	22 Nov 2006 04:24:02 -0000	1.9
+++ src/language/expressions/operations.def	5 Dec 2006 06:36:44 -0000
@@ -908,7 +908,7 @@ no_opt operator VEC_ELEM_NUM (idx)
     {
       const struct variable *var = v->var[(int) idx - 1];
       double value = case_num (c, var->fv);
-      return !mv_is_num_user_missing (&var->miss, value) ? value : SYSMIS; 
+      return !var_is_num_user_missing (var, value) ? value : SYSMIS; 
     }
   else
     {
@@ -932,7 +932,7 @@ absorb_miss no_opt string operator VEC_E
   if (idx >= 1 && idx <= v->cnt)
     {
       struct variable *var = v->var[(int) idx - 1];
-      return copy_string (e, case_str (c, var->fv), var->width);
+      return copy_string (e, case_str (c, var->fv), var_get_width (var));
     }
   else
     {
@@ -955,7 +955,7 @@ no_opt operator NUM_VAR ()
      num_var v;
 {
   double d = case_num (c, v->fv);
-  return !mv_is_num_user_missing (&v->miss, d) ? d : SYSMIS;
+  return !var_is_num_user_missing (v, d) ? d : SYSMIS;
 }
 
 no_opt string operator STR_VAR ()
@@ -963,8 +963,8 @@ no_opt string operator STR_VAR ()
      expression e;
      str_var v;
 {
-  struct substring s = alloc_string (e, v->width);
-  memcpy (s.string, case_str (c, v->fv), v->width);
+  struct substring s = alloc_string (e, var_get_width (v));
+  memcpy (s.string, case_str (c, v->fv), var_get_width (v));
   return s;
 }
 
@@ -975,7 +975,7 @@ no_opt perm_only function LAG (num_var v
   if (c != NULL)
     {
       double x = case_num (c, v->fv);
-      return !mv_is_num_user_missing (&v->miss, x) ? x : SYSMIS;
+      return !var_is_num_user_missing (v, x) ? x : SYSMIS;
     }
   else
     return SYSMIS;
@@ -988,7 +988,7 @@ no_opt perm_only function LAG (num_var v
   if (c != NULL)
     {
       double x = case_num (c, v->fv);
-      return !mv_is_num_user_missing (&v->miss, x) ? x : SYSMIS;
+      return !var_is_num_user_missing (v, x) ? x : SYSMIS;
     }
   else
     return SYSMIS;
@@ -1000,7 +1000,7 @@ no_opt perm_only string function LAG (st
 {
   struct ccase *c = lagged_case (ds, n_before);
   if (c != NULL)
-    return copy_string (e, case_str (c, v->fv), v->width);
+    return copy_string (e, case_str (c, v->fv), var_get_width (v));
   else
     return empty_string;
 }
@@ -1011,7 +1011,7 @@ no_opt perm_only string function LAG (st
 {
   struct ccase *c = lagged_case (ds, 1);
   if (c != NULL)
-    return copy_string (e, case_str (c, v->fv), v->width);
+    return copy_string (e, case_str (c, v->fv), var_get_width (v));
   else
     return empty_string;
 }
Index: src/language/expressions/parse.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/parse.c,v
retrieving revision 1.18
diff -u -p -r1.18 parse.c
--- src/language/expressions/parse.c	11 Nov 2006 23:10:00 -0000	1.18
+++ src/language/expressions/parse.c	5 Dec 2006 06:36:47 -0000
@@ -901,7 +901,7 @@ parse_vector_element (struct lexer *lexe
       || !lex_match (lexer, ')'))
     return NULL;
 
-  return expr_allocate_binary (e, (vector->var[0]->type == NUMERIC
+  return expr_allocate_binary (e, (var_is_numeric (vector->var[0])
                                    ? OP_VEC_ELEM_NUM : OP_VEC_ELEM_STR),
                                element, expr_allocate_vector (e, vector));
 }
@@ -1464,7 +1464,7 @@ union any_node *
 expr_allocate_variable (struct expression *e, struct variable *v)
 {
   union any_node *n = pool_alloc (e->expr_pool, sizeof n->variable);
-  n->type = v->type == NUMERIC ? OP_num_var : OP_str_var;
+  n->type = var_is_numeric (v) ? OP_num_var : OP_str_var;
   n->variable.v = v;
   return n;
 }
@@ -1484,6 +1484,6 @@ static union any_node *
 allocate_unary_variable (struct expression *e, struct variable *v) 
 {
   assert (v != NULL);
-  return expr_allocate_unary (e, v->type == NUMERIC ? OP_NUM_VAR : OP_STR_VAR,
+  return expr_allocate_unary (e, var_is_numeric (v) ? OP_NUM_VAR : OP_STR_VAR,
                               expr_allocate_variable (e, v));
 }
Index: src/language/lexer/variable-parser.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/variable-parser.c,v
retrieving revision 1.11
diff -u -p -r1.11 variable-parser.c
--- src/language/lexer/variable-parser.c	11 Nov 2006 23:10:00 -0000	1.11
+++ src/language/lexer/variable-parser.c	5 Dec 2006 06:36:47 -0000
@@ -148,7 +148,7 @@ parse_var_idx_class (struct lexer *lexer
   if (!parse_vs_variable_idx (lexer, vs, idx))
     return false;
 
-  *class = dict_class_from_id (var_set_get_var (vs, *idx)->name);
+  *class = dict_class_from_id (var_get_name (var_set_get_var (vs, *idx)));
   return true;
 }
 
@@ -163,24 +163,26 @@ add_variable (struct variable ***v, size
               const struct var_set *vs, size_t idx)
 {
   struct variable *add = var_set_get_var (vs, idx);
+  const char *add_name = var_get_name (add);
 
-  if ((pv_opts & PV_NUMERIC) && add->type != NUMERIC) 
+  if ((pv_opts & PV_NUMERIC) && !var_is_numeric (add)) 
     msg (SW, _("%s is not a numeric variable.  It will not be "
-               "included in the variable list."), add->name);
-  else if ((pv_opts & PV_STRING) && add->type != ALPHA) 
+               "included in the variable list."), add_name);
+  else if ((pv_opts & PV_STRING) && !var_is_alpha (add)) 
     msg (SE, _("%s is not a string variable.  It will not be "
-               "included in the variable list."), add->name);
+               "included in the variable list."), add_name);
   else if ((pv_opts & PV_NO_SCRATCH)
-           && dict_class_from_id (add->name) == DC_SCRATCH)
+           && dict_class_from_id (add_name) == DC_SCRATCH)
     msg (SE, _("Scratch variables (such as %s) are not allowed "
-               "here."), add->name);
-  else if ((pv_opts & PV_SAME_TYPE) && *nv && add->type != (*v)[0]->type) 
+               "here."), add_name);
+  else if ((pv_opts & PV_SAME_TYPE) && *nv
+           && var_get_type (add) != var_get_type ((*v)[0])) 
     msg (SE, _("%s and %s are not the same type.  All variables in "
                "this variable list must be of the same type.  %s "
                "will be omitted from list."),
-         (*v)[0]->name, add->name, add->name);
+         var_get_name ((*v)[0]), add_name, add_name);
   else if ((pv_opts & PV_NO_DUPLICATE) && included[idx]) 
-    msg (SE, _("Variable %s appears twice in variable list."), add->name);
+    msg (SE, _("Variable %s appears twice in variable list."), add_name);
   else if ((pv_opts & PV_DUPLICATE) || !included[idx])
     {
       if (*nv >= *mv)
@@ -208,7 +210,7 @@ add_variables (struct variable ***v, siz
   size_t i;
   
   for (i = first_idx; i <= last_idx; i++)
-    if (dict_class_from_id (var_set_get_var (vs, i)->name) == class)
+    if (dict_class_from_id (var_get_name (var_set_get_var (vs, i))) == class)
       add_variable (v, nv, mv, included, pv_opts, vs, i);
 }
 
@@ -285,10 +287,11 @@ parse_var_set_vars (struct lexer *lexer,
 
               if (last_idx < first_idx)
                 {
+                  const char *first_name = var_get_name (first_var);
+                  const char *last_name = var_get_name (last_var);
                   msg (SE, _("%s TO %s is not valid syntax since %s "
                              "precedes %s in the dictionary."),
-                       first_var->name, last_var->name,
-                       first_var->name, last_var->name);
+                       first_name, last_name, first_name, last_name);
                   goto fail;
                 }
 
@@ -299,8 +302,9 @@ parse_var_set_vars (struct lexer *lexer,
                              "the same variable dictionaries, of either "
                              "ordinary, scratch, or system variables.  "
                              "%s is a %s variable, whereas %s is %s."),
-                       first_var->name, dict_class_to_name (class),
-                       last_var->name, dict_class_to_name (last_class));
+                       var_get_name (first_var), dict_class_to_name (class),
+                       var_get_name (last_var),
+                       dict_class_to_name (last_class));
                   goto fail;
                 }
 
@@ -552,7 +556,7 @@ parse_mixed_vars (struct lexer *lexer, c
 	    goto fail;
 	  *names = xnrealloc (*names, *nnames + nv, sizeof **names);
 	  for (i = 0; i < nv; i++)
-	    (*names)[*nnames + i] = xstrdup (v[i]->name);
+	    (*names)[*nnames + i] = xstrdup (var_get_name (v[i]));
 	  free (v);
 	  *nnames += nv;
 	}
Index: src/language/stats/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/ChangeLog,v
retrieving revision 1.31
diff -u -p -r1.31 ChangeLog
--- src/language/stats/ChangeLog	5 Nov 2006 00:35:43 -0000	1.31
+++ src/language/stats/ChangeLog	5 Dec 2006 06:36:47 -0000
@@ -1,3 +1,15 @@
+Mon Dec  4 22:33:46 2006  Ben Pfaff  <blp@gnu.org>
+
+	* crosstabs.q (insert_summary): Use var_to_string for labeling.
+	(output_pivot_table) Ditto.
+	(submit) Ditto.
+
+	* frequencies.q (setup_z_trns): Ditto.
+	(dump_full) Ditto.
+	(dump_condensed) Ditto.
+	(dump_statistics) Ditto.
+	
+
 Sun Nov  5 08:31:42 WST 2006 John Darrington <john@darrington.wattle.id.au>
 
 	* t-test.q, oneway.q: Changed to use the new casefilter structure.
Index: src/language/stats/aggregate.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/aggregate.c,v
retrieving revision 1.20
diff -u -p -r1.20 aggregate.c
--- src/language/stats/aggregate.c	25 Nov 2006 02:15:01 -0000	1.20
+++ src/language/stats/aggregate.c	5 Dec 2006 06:36:47 -0000
@@ -237,7 +237,7 @@ cmd_aggregate (struct lexer *lexer, stru
 	  
           for (i = 0; i < agr.break_var_cnt; i++)
             dict_clone_var_assert (agr.dict, agr.break_vars[i],
-                                   agr.break_vars[i]->name);
+                                   var_get_name (agr.break_vars[i]));
 
           /* BREAK must follow the options. */
           break;
@@ -508,7 +508,7 @@ parse_aggregate_functions (struct lexer 
 	    
 		lex_get (lexer);
 
-		if (type != src[0]->type)
+		if (type != var_get_type (src[0]))
 		  {
 		    msg (SE, _("Arguments to %s must be of same type as "
 			       "source variables."),
@@ -540,9 +540,9 @@ parse_aggregate_functions (struct lexer 
 
           if ((func_index == PIN || func_index == POUT
               || func_index == FIN || func_index == FOUT) 
-              && ((src[0]->type == NUMERIC && arg[0].f > arg[1].f)
-                  || (src[0]->type == ALPHA
-                      && str_compare_rpad (arg[0].c, arg[1].c) > 0)))
+              && (var_is_numeric (src[0])
+                  ? arg[0].f > arg[1].f
+                  : str_compare_rpad (arg[0].c, arg[1].c) > 0))
             {
               union agr_argument t = arg[0];
               arg[0] = arg[1];
@@ -581,17 +581,17 @@ parse_aggregate_functions (struct lexer 
 	      {
 		v->src = src[i];
 		
-		if (src[i]->type == ALPHA)
+		if (var_is_alpha (src[i]))
 		  {
 		    v->function |= FSTRING;
-		    v->string = xmalloc (src[i]->width);
+		    v->string = xmalloc (var_get_width (src[i]));
 		  }
 
 		if (function->alpha_type == ALPHA)
 		  destvar = dict_clone_var (agr->dict, v->src, dest[i]);
 		else
                   {
-                    assert (v->src->type == NUMERIC
+                    assert (var_is_numeric (v->src)
                             || function->alpha_type == NUMERIC);
                     destvar = dict_create_var (agr->dict, dest[i], 0);
                     if (destvar != NULL) 
@@ -602,7 +602,7 @@ parse_aggregate_functions (struct lexer 
                           f = fmt_for_output (FMT_F, 8, 2); 
                         else
                           f = function->format;
-                        destvar->print = destvar->write = f;
+                        var_set_both_formats (destvar, &f);
                       }
                   }
 	      } else {
@@ -613,7 +613,7 @@ parse_aggregate_functions (struct lexer 
                   f = fmt_for_output (FMT_F, 8, 2); 
                 else
                   f = function->format;
-                destvar->print = destvar->write = f;
+                var_set_both_formats (destvar, &f);
 	      }
 	  
 	    if (!destvar)
@@ -628,10 +628,7 @@ parse_aggregate_functions (struct lexer 
 
 	    free (dest[i]);
 	    if (dest_label[i])
-	      {
-		destvar->label = dest_label[i];
-		dest_label[i] = NULL;
-	      }
+              var_set_label (destvar, dest_label[i]);
 
 	    v->dest = destvar;
 	  }
@@ -642,7 +639,7 @@ parse_aggregate_functions (struct lexer 
 	    {
 	      int j;
 
-	      if (v->src->type == NUMERIC)
+	      if (var_is_numeric (v->src))
 		for (j = 0; j < function->n_args; j++)
 		  v->arg[j].f = arg[j].f;
 	      else
@@ -651,7 +648,7 @@ parse_aggregate_functions (struct lexer 
 	    }
 	}
       
-      if (src != NULL && src[0]->type == ALPHA)
+      if (src != NULL && var_is_alpha (src[0]))
 	for (i = 0; i < function->n_args; i++)
 	  {
 	    free (arg[i].c);
@@ -683,7 +680,7 @@ parse_aggregate_functions (struct lexer 
       free (dest_label);
       free (arg[0].c);
       free (arg[1].c);
-      if (src && n_src && src[0]->type == ALPHA)
+      if (src && n_src && var_is_alpha (src[0]))
 	for (i = 0; i < function->n_args; i++)
 	  {
 	    free (arg[i].c);
@@ -775,11 +772,11 @@ accumulate_aggregate_info (struct agr_pr
     if (iter->src)
       {
 	const union value *v = case_data (input, iter->src->fv);
+        int src_width = var_get_width (iter->src);
 
-	if ((!iter->include_missing
-             && mv_is_value_missing (&iter->src->miss, v))
-	    || (iter->include_missing && iter->src->type == NUMERIC
-		&& v->f == SYSMIS))
+	if (iter->include_missing
+            ? var_is_numeric (iter->src) && v->f == SYSMIS
+            : var_is_value_missing (iter->src, v))
 	  {
 	    switch (iter->function)
 	      {
@@ -815,8 +812,8 @@ accumulate_aggregate_info (struct agr_pr
 	    iter->int1 = 1;
 	    break;
 	  case MAX | FSTRING:
-	    if (memcmp (iter->string, v->s, iter->src->width) < 0)
-	      memcpy (iter->string, v->s, iter->src->width);
+	    if (memcmp (iter->string, v->s, src_width) < 0)
+	      memcpy (iter->string, v->s, src_width);
 	    iter->int1 = 1;
 	    break;
 	  case MIN:
@@ -824,8 +821,8 @@ accumulate_aggregate_info (struct agr_pr
 	    iter->int1 = 1;
 	    break;
 	  case MIN | FSTRING:
-	    if (memcmp (iter->string, v->s, iter->src->width) > 0)
-	      memcpy (iter->string, v->s, iter->src->width);
+	    if (memcmp (iter->string, v->s, src_width) > 0)
+	      memcpy (iter->string, v->s, src_width);
 	    iter->int1 = 1;
 	    break;
 	  case FGT:
@@ -836,7 +833,7 @@ accumulate_aggregate_info (struct agr_pr
             break;
 	  case FGT | FSTRING:
 	  case PGT | FSTRING:
-            if (memcmp (iter->arg[0].c, v->s, iter->src->width) < 0)
+            if (memcmp (iter->arg[0].c, v->s, src_width) < 0)
               iter->dbl[0] += weight;
             iter->dbl[1] += weight;
             break;
@@ -848,7 +845,7 @@ accumulate_aggregate_info (struct agr_pr
             break;
 	  case FLT | FSTRING:
 	  case PLT | FSTRING:
-            if (memcmp (iter->arg[0].c, v->s, iter->src->width) > 0)
+            if (memcmp (iter->arg[0].c, v->s, src_width) > 0)
               iter->dbl[0] += weight;
             iter->dbl[1] += weight;
             break;
@@ -860,8 +857,8 @@ accumulate_aggregate_info (struct agr_pr
             break;
 	  case FIN | FSTRING:
 	  case PIN | FSTRING:
-            if (memcmp (iter->arg[0].c, v->s, iter->src->width) <= 0
-                && memcmp (iter->arg[1].c, v->s, iter->src->width) >= 0)
+            if (memcmp (iter->arg[0].c, v->s, src_width) <= 0
+                && memcmp (iter->arg[1].c, v->s, src_width) >= 0)
               iter->dbl[0] += weight;
             iter->dbl[1] += weight;
             break;
@@ -873,8 +870,8 @@ accumulate_aggregate_info (struct agr_pr
             break;
 	  case FOUT | FSTRING:
 	  case POUT | FSTRING:
-            if (memcmp (iter->arg[0].c, v->s, iter->src->width) > 0
-                || memcmp (iter->arg[1].c, v->s, iter->src->width) < 0)
+            if (memcmp (iter->arg[0].c, v->s, src_width) > 0
+                || memcmp (iter->arg[1].c, v->s, src_width) < 0)
               iter->dbl[0] += weight;
             iter->dbl[1] += weight;
             break;
@@ -896,7 +893,7 @@ accumulate_aggregate_info (struct agr_pr
 	  case FIRST | FSTRING:
 	    if (iter->int1 == 0)
 	      {
-		memcpy (iter->string, v->s, iter->src->width);
+		memcpy (iter->string, v->s, src_width);
 		iter->int1 = 1;
 	      }
 	    break;
@@ -905,7 +902,7 @@ accumulate_aggregate_info (struct agr_pr
 	    iter->int1 = 1;
 	    break;
 	  case LAST | FSTRING:
-	    memcpy (iter->string, v->s, iter->src->width);
+	    memcpy (iter->string, v->s, src_width);
 	    iter->int1 = 1;
 	    break;
           case NMISS:
@@ -946,10 +943,11 @@ dump_aggregate_info (struct agr_proc *ag
     for (i = 0; i < agr->break_var_cnt; i++) 
       {
         struct variable *v = agr->break_vars[i];
+        size_t value_cnt = var_get_value_cnt (v);
         memcpy (case_data_rw (output, value_idx),
                 case_data (&agr->break_case, v->fv),
-                sizeof (union value) * v->nv);
-        value_idx += v->nv; 
+                sizeof (union value) * value_cnt);
+        value_idx += value_cnt; 
       }
   }
   
@@ -964,8 +962,8 @@ dump_aggregate_info (struct agr_proc *ag
 	    && (i->function & FUNC) != N && (i->function & FUNC) != NU
 	    && (i->function & FUNC) != NMISS && (i->function & FUNC) != NUMISS)
 	  {
-	    if (i->dest->type == ALPHA)
-	      memset (v->s, ' ', i->dest->width);
+	    if (var_is_alpha (i->dest))
+	      memset (v->s, ' ', var_get_width (i->dest));
 	    else
 	      v->f = SYSMIS;
 	    continue;
@@ -999,9 +997,9 @@ dump_aggregate_info (struct agr_proc *ag
 	  case MAX | FSTRING:
 	  case MIN | FSTRING:
 	    if (i->int1)
-	      memcpy (v->s, i->string, i->dest->width);
+	      memcpy (v->s, i->string, var_get_width (i->dest));
 	    else
-	      memset (v->s, ' ', i->dest->width);
+	      memset (v->s, ' ', var_get_width (i->dest));
 	    break;
 	  case FGT:
 	  case FGT | FSTRING:
@@ -1038,9 +1036,9 @@ dump_aggregate_info (struct agr_proc *ag
 	  case FIRST | FSTRING:
 	  case LAST | FSTRING:
 	    if (i->int1)
-	      memcpy (v->s, i->string, i->dest->width);
+	      memcpy (v->s, i->string, var_get_width (i->dest));
 	    else
-	      memset (v->s, ' ', i->dest->width);
+	      memset (v->s, ' ', var_get_width (i->dest));
 	    break;
 	  case N_NO_VARS:
 	    v->f = i->dbl[0];
@@ -1083,13 +1081,13 @@ initialize_aggregate_info (struct agr_pr
 	  iter->dbl[0] = DBL_MAX;
 	  break;
 	case MIN | FSTRING:
-	  memset (iter->string, 255, iter->src->width);
+	  memset (iter->string, 255, var_get_width (iter->src));
 	  break;
 	case MAX:
 	  iter->dbl[0] = -DBL_MAX;
 	  break;
 	case MAX | FSTRING:
-	  memset (iter->string, 0, iter->src->width);
+	  memset (iter->string, 0, var_get_width (iter->src));
 	  break;
         case SD:
           if (iter->moments == NULL)
Index: src/language/stats/autorecode.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/autorecode.c,v
retrieving revision 1.14
diff -u -p -r1.14 autorecode.c
--- src/language/stats/autorecode.c	11 Nov 2006 23:10:00 -0000	1.14
+++ src/language/stats/autorecode.c	5 Dec 2006 06:36:47 -0000
@@ -178,7 +178,7 @@ cmd_autorecode (struct lexer *lexer, str
   arc.dst_vars = xnmalloc (arc.var_cnt, sizeof *arc.dst_vars);
   arc.src_values = xnmalloc (arc.var_cnt, sizeof *arc.src_values);
   for (i = 0; i < dst_cnt; i++)
-    if (arc.src_vars[i]->type == ALPHA)
+    if (var_is_alpha (arc.src_vars[i]))
       arc.src_values[i] = hsh_create (10, compare_alpha_value,
                                       hash_alpha_value, NULL, arc.src_vars[i]);
     else
@@ -246,7 +246,7 @@ recode (struct dataset *ds, const struct
       spec->src = arc->src_vars[i];
       spec->dest = arc->dst_vars[i];
 
-      if (arc->src_vars[i]->type == ALPHA)
+      if (var_is_alpha (arc->src_vars[i]))
 	spec->items = hsh_create (2 * count, compare_alpha_value,
 				  hash_alpha_value, NULL, arc->src_vars[i]);
       else
@@ -258,11 +258,11 @@ recode (struct dataset *ds, const struct
 	  struct arc_item *item = pool_alloc (trns->pool, sizeof *item);
           union arc_value *vp = *p;
           
-	  if (arc->src_vars[i]->type == NUMERIC)
+	  if (var_is_numeric (arc->src_vars[i]))
             item->from.f = vp->f;
           else
 	    item->from.c = pool_clone (trns->pool, vp->c,
-                                       arc->src_vars[i]->width);
+                                       var_get_width (arc->src_vars[i]));
 	  item->to = arc->direction == ASCENDING ? j + 1 : count - j;
 	  hsh_force_insert (spec->items, item);
 	}
@@ -284,7 +284,7 @@ autorecode_trns_proc (void *trns_, struc
       struct arc_item *item;
       union arc_value v;
 
-      if (spec->src->type == NUMERIC)
+      if (var_is_numeric (spec->src))
         v.f = case_num (c, spec->src->fv);
       else
         v.c = (char *) case_str (c, spec->src->fv);
@@ -317,7 +317,7 @@ compare_alpha_value (const void *a_, con
   const union arc_value *b = b_;
   const struct variable *v = v_;
 
-  return memcmp (a->c, b->c, v->width);
+  return memcmp (a->c, b->c, var_get_width (v));
 }
 
 static unsigned
@@ -326,7 +326,7 @@ hash_alpha_value (const void *a_, const 
   const union arc_value *a = a_;
   const struct variable *v = v_;
   
-  return hsh_hash_bytes (a->c, v->width);
+  return hsh_hash_bytes (a->c, var_get_width (v));
 }
 
 static int
@@ -356,7 +356,7 @@ autorecode_proc_func (const struct ccase
     {
       union arc_value v, *vp, **vpp;
 
-      if (arc->src_vars[i]->type == NUMERIC)
+      if (var_is_numeric (arc->src_vars[i]))
         v.f = case_num (c, arc->src_vars[i]->fv);
       else
         v.c = (char *) case_str (c, arc->src_vars[i]->fv);
@@ -365,11 +365,11 @@ autorecode_proc_func (const struct ccase
       if (*vpp == NULL)
         {
           vp = pool_alloc (arc->src_values_pool, sizeof *vp);
-          if (arc->src_vars[i]->type == NUMERIC)
+          if (var_is_numeric (arc->src_vars[i]))
             vp->f = v.f;
           else
             vp->c = pool_clone (arc->src_values_pool,
-                                v.c, arc->src_vars[i]->width);
+                                v.c, var_get_width (arc->src_vars[i]));
           *vpp = vp;
         }
     }
